// Generated by CoffeeScript 1.7.1
(function() {
  var collectCoffeeFiles, defaultLintOptions, findScript, glob, log, ninjaFactories, setLintOptions, _;

  ninjaFactories = require('./ninjaFactories');

  findScript = require('./ninjaCommands').findScript;

  _ = require('lodash');

  log = require('yadsil')('index');

  glob = require('glob');

  collectCoffeeFiles = function(_arg) {
    var extensionMark, extensions, paths;
    extensions = _arg.extensions, paths = _arg.paths;
    log.info('looking for coffee script files..');
    extensionMark = '$ext';
    return _.chain(paths).map(function(path) {
      return extensions.map(function(ext) {
        return path.replace(extensionMark, ext);
      });
    }).flatten().map(function(path) {
      return glob.sync(path);
    }).flatten().value();
  };

  defaultLintOptions = {
    extensions: ['coffee', '_coffee'],
    paths: ['src/**/*.$ext', 'assets/js/**/*.$ext', 'bin/**/*.$ext', 'Gruntfile.$ext']
  };

  setLintOptions = null;

  exports.configureCoffeelint = function(options) {
    return setLintOptions = options;
  };

  exports.getCoffeelintPaths = function() {
    return collectCoffeeFiles(setLintOptions != null ? setLintOptions : defaultLintOptions);
  };

  exports.defineFactory = ninjaFactories.defineFactory;

  exports.defineBrowserifyFactory = function(name, sourceFile, targetFile, options) {
    return exports.defineFactory("browserify-" + name, {
      makeRules: function(ninja, config) {
        return ['debug', 'release'].forEach(function(releaseType) {
          var cli, rule;
          cli = "$node " + (findScript('browserify-bundle.js'));
          if (options.extensions) {
            cli += " --extensions '" + (options.extensions.join(",")) + "'";
          }
          if (options.transforms) {
            cli += " --transforms '" + (options.transforms.join(",")) + "'";
          }
          cli += " --out $out --i18n $out.i18n";
          if (releaseType === 'debug') {
            cli += " --deps $out.d --debug";
          }
          cli += " ./$in";
          rule = ninja.rule("browserify-" + name + "-" + releaseType);
          rule.run(cli);
          if (releaseType === 'debug') {
            rule.depfile('$out.d');
          }
          return rule.description("(" + releaseType + ") BROWSERIFY $in");
        });
      },
      assetFiles: sourceFile,
      makeAssetEdge: function(ninja, source, target, releaseType) {
        target = "build/assets/" + releaseType + "/js/" + targetFile;
        ninja.edge(target).from(source).using("browserify-" + name + "-" + releaseType);
        return [target];
      }
    });
  };

}).call(this);

//# sourceMappingURL=index.map
